#粒子群最適化（Particle Swarm Optimization）
#  ただし，最低値を最適とみなす
import random
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
NUM=10 #粒子群の数
def setInitX(NUM):#■座標値初期化
    X=array(NUM)#　粒子群の座標値
    for i in range(NUM):X[i]=random.random()*10
    return X
def setInitV(NUM):#■速度初期化
    V=array(NUM)  #  粒子群の速度
    for i in range(NUM):V[i]=(random.random()-0.5)*10
    return V
def fitV(X):#■適合度計算
    return (X-1)*(X-4)*(X-7)*(X-9)+71
def initFit(X):#■適合度の初期化
    NUM=len(X); F=array(NUM,2)
    for i in range(NUM):
        F[i][0]=fitV(X[i]);F[i][1]=X[i]
    return F
def bestAll(F):#■全体の最適値を求める
    ID=0; Mn=F[0][0]#（ここでは最低値を最適とする）
    for i in range(1,len(F)):
        if F[i][0]<Mn: ID=i;Mn=F[i][0]
    return [F[ID][0],F[ID][1]]
def printX(i, X):#■Xとその適合度を表示
    NUM=len(X); S="%4d"%i
    for k in range(len(X)):
        S+=", %6.4f"% X[k]
    for k in range(len(X)):
        S+=", %6.4f"% fitV(X[k])
    print(S)
c1=0.9; c2=0.9;w=0.9
X=setInitX(NUM); V=setInitV(NUM)
F=initFit(X); bestX=bestAll(F);EPS=9999
for i in range(1000):#1000回の繰返し
    if EPS<0.0000001:break #全体最適値収れんのとき終わり
    for k in range(NUM):#粒子数で繰返し
        X[k]=X[k]+V[k]; nF=fitV(X[k])#座標変更と適合度計算
        if nF<F[k][0]:# 小さいほうを最適とみなす
            F[k][0]=nF;F[k][1]=X[k]
        if nF<bestX[0]:# 小さいほうを最適とみなす
            EPS=bestX[0]-nF
            bestX[0]=nF;bestX[1]=X[k]
            #print(bestX, diffV(X[k])) 
        r1=random.random(); r2=random.random()
        V[k]=(w*V[k]+c1*r1*(F[k][1]-X[k])+
              c2*r2*(bestX[1]-X[k])) #速度変更
    printX(i,X)
print(bestX)
